#include <userint.h>

#include <ansi_c.h>

#define nstep 100
#define a 1.
#define b 1.
#define pi acos(-1)
#define Vnul 10.
#define nmax 101

// Dit programma gaat de potentiaal uitrekenen in een rechthoekig vlak xy.
// Er wordt gebruik gemaakt van de analytische methode van Morse en Feshbach.

double Va (float,float)			;	/* double functie die V berekend
						   uit F1,F2,F3 en F4 	      */
double F1 (int)				;	/* functie F1 */
double F2 (int,float)			;	/* Functie F2 */
double F3 (int,float)			;	/* Functie F3 */
double F4 (int)				;	/* Functie F4 */


int main(void)
{

	int    n				; /* variabele 		     */
	int err;
	float x[nstep]				; /* tabel voor de x-waarden */
	float y[nstep]				; /* tabel voor de y-waarden */

	int   i			;	/* teller 1e dimensie		*/
	int   j			;	/* teller 2e dimensie		*/
	float xmin = 0.		;	/* ondergrens voor x		*/
	float xmax = 1.		;	/* bovengrens voor x		*/
	float ymin = 0.		;	/* ondergrens voor y		*/
	float ymax = 1.		;	/* bovengrens voor y		*/
	float hx		;	/* stapgrootte x-richting	*/
	float hy		;	/* stapgrootte y-richting	*/
	float V[nstep][nstep]	;	/* de potentiaal V		*/
	double Vxy[nstep] ;  /* used for 2D plotting at fixed x or y */
    double xy[nstep];    /* used for plotting. */
	hx   = ( xmax - xmin ) / nstep	; /* de brekening van de stapgrootten */
	hy   = ( ymax - ymin ) / nstep	;



	for(i=0;i<nstep;i=i+1)
	{

		for(j=0;j<nstep;j=j+1)
		{
			x[i] = i*hx	; /* de x- en y-intervallen definieren */
			y[j] = j*hy	;
			V[i][j] = 0.;	; /* alle waarden van V op nul zetten  */
		}

	}


	for(i=1;i<nstep-1;i=i+1)
	{
			/* de functie Va alle waarden laten berekenen	      */
		for(j=1;j<nstep-1;j=j+1)	
		{
			V[i][j] = Va(x[i],y[j])		;
		}	/* Va laat op zijn beurt weer F1 t/m F4 het werk doen */
               V[i][0]=Vnul;
	}

   /* plot tegen x for y = nstep/2  */
	for(i=1;i<nstep;i=i+1) {  
		 Vxy[i]=V[i][nstep/2];
		 xy[i]=x[i];
	}
	err = XYGraphPopup ("V tegen x", xy, Vxy, nstep, VAL_DOUBLE,
										VAL_DOUBLE);
	
	/* plot V tegen y for vaste x  */
		for(i=1;i<nstep;i=i+1) {  
		 Vxy[i]=V[nstep/2][i];
		 xy[i]=y[i];
	}
	err = XYGraphPopup ("V tegen x", xy, Vxy, nstep, VAL_DOUBLE,
										VAL_DOUBLE);
	
	
	
  return 0;
}
	/* de functie Va wordt hier buiten de main gezet */
	double Va(float x, float y)
	{
	double 	V = 0.  	;
	double 	Vbijdrage = 0.	;
	int 	n		;

	for(n=1;n<nmax;n=n+2)	/* deze for-loop berekend Va uit F1 t/m F4 */
		{

		Vbijdrage = (2.*Vnul/pi) * F1(n)*F2(n,x)*F3(n,y)/F4(n)	;

		V = V + Vbijdrage	;

			if(fabs(Vbijdrage/V) < pow(10.,-20.))
			{
                       
			break	; /* zodra de bijdrage aan V kleiner wordt dan */
			}	  /* 10^-20, wordt de loop afgebroken	       */
		}

	return V;	/* een waarde voor V wordt geretourneerd */
	}

	double F1 (int n)		/* functie F1 */
	{
	double antw1	;
	antw1 = ( 1./n ) * ( 1.- pow(-1.,n) )	;	/* de formule voor F1 */
	return antw1;
	}

	double F2 (int n, float x) 	/* functie F2 */
	{
	double antw2 = sin( ( pi*n*x ) / a )	;	/* de formule voor F2 */
	return antw2 ;
	}

	double F3 (int n, float y) 	/* functie F3 */
	{
	double antw3 = ( ( exp( ( (pi*n) / a ) * ( b - y ) )
			- exp( ( (-pi*n) / a ) * ( b - y ) ) ) /2. )	;
	return antw3;					/* de formule voor F3 */
	}

	double F4 (int n)		/* functie F4 */
	{
	double antw4 = ( exp( (pi*n*b) / a ) - exp( (-pi*n*b) / a ) ) / 2.	;
	return antw4;					/* de formule voor F4 */
	}
/* de functies F1 t/m F4 retourneren allemaal hun antw zodat Va ze kan combineren */
